#include <msp430x14x.h>

// ˿
#define PORT_DS1302_CTL_OUT           (P6OUT)
#define PORT_DS1302_CTL_IN            (P6IN)
#define PORT_DS1302_CTL_DIR           (P6DIR)
// Ŷ
#define PIN_DS1302_CSK                BIT3
#define PIN_DS1302_DIO                BIT4
#define PIN_DS1302_RST                BIT5
// Ŷ
#define PIN_DS1302_SCK_HIGH           PORT_DS1302_CTL_OUT |=  PIN_DS1302_CSK
#define PIN_DS1302_SCK_LOW            PORT_DS1302_CTL_OUT &= ~PIN_DS1302_CSK
#define PIN_DS1302_SCK_DOUT           PORT_DS1302_CTL_DIR |=  PIN_DS1302_CSK
#define PIN_DS1302_SCK_DIN            PORT_DS1302_CTL_DIR &= ~PIN_DS1302_CSK
#define PIN_DS1302_DIO_HIGH           PORT_DS1302_CTL_OUT |=  PIN_DS1302_DIO
#define PIN_DS1302_DIO_LOW            PORT_DS1302_CTL_OUT &= ~PIN_DS1302_DIO
#define PIN_DS1302_DIO_DOUT           PORT_DS1302_CTL_DIR |=  PIN_DS1302_DIO
#define PIN_DS1302_DIO_DIN            PORT_DS1302_CTL_DIR &= ~PIN_DS1302_DIO
#define PIN_DS1302_RST_HIGH           PORT_DS1302_CTL_OUT |=  PIN_DS1302_RST
#define PIN_DS1302_RST_LOW            PORT_DS1302_CTL_OUT &= ~PIN_DS1302_RST
#define PIN_DS1302_RST_DOUT           PORT_DS1302_CTL_DIR |=  PIN_DS1302_RST
#define PIN_DS1302_RST_DIN            PORT_DS1302_CTL_DIR &= ~PIN_DS1302_RST

unsigned char LastSecond;
unsigned int Count_SaveData = 59;
struct strTime
{
  unsigned char Year;
  unsigned char Month;
  unsigned char Day;
  unsigned char Week;
  unsigned char Hour;
  unsigned char Minute;
  unsigned char Second;
} Now;


unsigned char BCDtoDEC(unsigned char BCD)
{
  unsigned char TempH;
  unsigned char TempL;
  unsigned char DEC;
  TempH = (BCD & 0xf0) >> 4;
  TempL = (BCD & 0x0f);
  DEC = TempH * 10 + TempL;
  return (DEC);
}

unsigned char DECtoBCD(unsigned char DEC)
{
  unsigned char TempH;
  unsigned char TempL;
  unsigned char BCD;
  TempH = (DEC / 10) << 4;
  TempL = DEC % 10;
  BCD = TempH + TempL;
  return (BCD);
}


// DS1302д1Byte
void DS1302_ByteWrite(unsigned char Data)
{
  unsigned char i;
  PIN_DS1302_DIO_DOUT;          // DIO 
  PIN_DS1302_SCK_DOUT;          // SCK 
  for(i=0; i<8; i++)
  {      
    if ( Data & 0x01 == 0x01)
    {
      PIN_DS1302_DIO_HIGH;      // жϷλ
    } 
    else 
    {
      PIN_DS1302_DIO_LOW; 
    }
    Data = Data >> 1; 
    PIN_DS1302_SCK_HIGH;      // DS1302_SCLK = 1;
    PIN_DS1302_SCK_LOW;       // DS1302_SCLK= 0;
  }
  PIN_DS1302_DIO_DIN;          // DIO 
  PIN_DS1302_SCK_DIN;          // SCK 
}
             
// DS1302ȡ1Byte
unsigned char DS1302_ByteRead(void)
{
  unsigned char i;
  unsigned char TempBit  = 0;
  unsigned char TempData = 0;
  
  PIN_DS1302_SCK_DOUT;          // SCK 
  for(i=0; i<8; i++)
  {  
    if ((PORT_DS1302_CTL_IN & PIN_DS1302_DIO) == PIN_DS1302_DIO)
    {
      TempBit = 0x80;
    }
    else
    {
      TempBit = 0x00;
    }
    TempData = (TempData >> 1) | TempBit;
    PIN_DS1302_SCK_HIGH;  // DS1302_SCLK = 1;
    PIN_DS1302_SCK_LOW;   // DS1302_SCLK= 0;
  }
  PIN_DS1302_SCK_DIN;          // SCK 
  return TempData;
}

// DS1302д
void DS1302_DataWrite(unsigned char Command, unsigned char Datas)
{
  PIN_DS1302_RST_DOUT;          // RST 
  PIN_DS1302_RST_HIGH;
  PIN_DS1302_SCK_LOW;           // DS1302_SCLK = 0
  DS1302_ByteWrite(Command);    // ַ
  DS1302_ByteWrite(Datas);      // д1Byte
  PIN_DS1302_RST_LOW;           //DS1302_RST  = 0;
  PIN_DS1302_RST_DIN;           // RST 
}

// ȡDS1302ĳַ
unsigned char DS1302_DataRead(char Command)
{
  unsigned char Datas; 
  PIN_DS1302_RST_DOUT;          // RST 
  PIN_DS1302_RST_HIGH;
  PIN_DS1302_SCK_LOW; 
  DS1302_ByteWrite(Command);    // ַ
  Datas = DS1302_ByteRead();    // 1Byte
  PIN_DS1302_RST_LOW;           // DS1302_RST  = 0;
  PIN_DS1302_RST_DIN;           // RST 
  return(Datas);
}


// óʼʱ(ʼʱʽΪ: ,,ʱ,,,,)
void DS1302_SetTime(unsigned char Year, unsigned char Month, unsigned char Day, 
                 unsigned char Week, unsigned char Hour, unsigned char Minute, unsigned char Second)
{
  DS1302_DataWrite(0x8e,0x00);                  // ȡд */
  DS1302_DataWrite(0x80,DECtoBCD(Second));      // 
  DS1302_DataWrite(0x82,DECtoBCD(Minute));      // ÷
  DS1302_DataWrite(0x84,DECtoBCD(Hour));        // Сʱ
  DS1302_DataWrite(0x86,DECtoBCD(Day));         // 
  DS1302_DataWrite(0x88,DECtoBCD(Month));       // 
  DS1302_DataWrite(0x8a,DECtoBCD(Week));        // ڼ
  DS1302_DataWrite(0x8c,DECtoBCD(Year));        // 
  DS1302_DataWrite(0x8e,0x80);                  // д */
}

// (ʼʱʽΪ: ,,ʱ,,,,)
void DS1302_SetYear(unsigned char Year)
{
  DS1302_DataWrite(0x8e,0x00);                  // ȡд */
  //DS1302_DataWrite(0x80,DECtoBCD(Second));      // 
  //DS1302_DataWrite(0x82,DECtoBCD(Minute));      // ÷
  //DS1302_DataWrite(0x84,DECtoBCD(Hour));        // Сʱ
  //DS1302_DataWrite(0x86,DECtoBCD(Day));         // 
  //DS1302_DataWrite(0x88,DECtoBCD(Month));       // 
  //DS1302_DataWrite(0x8a,DECtoBCD(Week));        // ڼ
  DS1302_DataWrite(0x8c,DECtoBCD(Year));        // 
  DS1302_DataWrite(0x8e,0x80);                  // д */
}

// (ʼʱʽΪ: ,,ʱ,,,,)
void DS1302_SetMonth(unsigned char Month)
{
  DS1302_DataWrite(0x8e,0x00);                  // ȡд */
  //DS1302_DataWrite(0x80,DECtoBCD(Second));      // 
  //DS1302_DataWrite(0x82,DECtoBCD(Minute));      // ÷
  //DS1302_DataWrite(0x84,DECtoBCD(Hour));        // Сʱ
  //DS1302_DataWrite(0x86,DECtoBCD(Day));         // 
  DS1302_DataWrite(0x88,DECtoBCD(Month));       // 
  //DS1302_DataWrite(0x8a,DECtoBCD(Week));        // ڼ
  //DS1302_DataWrite(0x8c,DECtoBCD(Year));        // 
  DS1302_DataWrite(0x8e,0x80);                  // д */
}

// (ʼʱʽΪ: ,,ʱ,,,,)
void DS1302_SetDay(unsigned char Day)
{
  DS1302_DataWrite(0x8e,0x00);                  // ȡд */
  //DS1302_DataWrite(0x80,DECtoBCD(Second));      // 
  //DS1302_DataWrite(0x82,DECtoBCD(Minute));      // ÷
  //DS1302_DataWrite(0x84,DECtoBCD(Hour));        // Сʱ
  DS1302_DataWrite(0x86,DECtoBCD(Day));         // 
  //DS1302_DataWrite(0x88,DECtoBCD(Month));       // 
  //DS1302_DataWrite(0x8a,DECtoBCD(Week));        // ڼ
  //DS1302_DataWrite(0x8c,DECtoBCD(Year));        // 
  DS1302_DataWrite(0x8e,0x80);                  // д */
}

// (ʼʱʽΪ: ,,ʱ,,,,)
void DS1302_SetWeek(unsigned char Week)
{
  DS1302_DataWrite(0x8e,0x00);                  // ȡд */
  //DS1302_DataWrite(0x80,DECtoBCD(Second));      // 
  //DS1302_DataWrite(0x82,DECtoBCD(Minute));      // ÷
  //DS1302_DataWrite(0x84,DECtoBCD(Hour));        // Сʱ
  //DS1302_DataWrite(0x86,DECtoBCD(Day));         // 
  //DS1302_DataWrite(0x88,DECtoBCD(Month));       // 
  DS1302_DataWrite(0x8a,DECtoBCD(Week));        // ڼ
  //DS1302_DataWrite(0x8c,DECtoBCD(Year));        // 
  DS1302_DataWrite(0x8e,0x80);                  // д */
}

// ʱ(ʼʱʽΪ: ,,ʱ,,,,)
void DS1302_SetHour(unsigned char Hour)
{
  DS1302_DataWrite(0x8e,0x00);                  // ȡд */
  //DS1302_DataWrite(0x80,DECtoBCD(Second));      // 
  //DS1302_DataWrite(0x82,DECtoBCD(Minute));      // ÷
  DS1302_DataWrite(0x84,DECtoBCD(Hour));        // Сʱ
  //DS1302_DataWrite(0x86,DECtoBCD(Day));         // 
  //DS1302_DataWrite(0x88,DECtoBCD(Month));       // 
  //DS1302_DataWrite(0x8a,DECtoBCD(Week));        // ڼ
  //DS1302_DataWrite(0x8c,DECtoBCD(Year));        // 
  DS1302_DataWrite(0x8e,0x80);                  // д */
}

// ÷(ʼʱʽΪ: ,,ʱ,,,,)
void DS1302_SetMinute(unsigned char Minute)
{
  DS1302_DataWrite(0x8e,0x00);                  // ȡд */
  //DS1302_DataWrite(0x80,DECtoBCD(Second));      // 
  DS1302_DataWrite(0x82,DECtoBCD(Minute));      // ÷
  //DS1302_DataWrite(0x84,DECtoBCD(Hour));        // Сʱ
  //DS1302_DataWrite(0x86,DECtoBCD(Day));         // 
  //DS1302_DataWrite(0x88,DECtoBCD(Month));       // 
  //DS1302_DataWrite(0x8a,DECtoBCD(Week));        // ڼ
  //DS1302_DataWrite(0x8c,DECtoBCD(Year));        // 
  DS1302_DataWrite(0x8e,0x80);                  // д */
}

// (ʼʱʽΪ: ,,ʱ,,,,)
void DS1302_SetSecond(unsigned char Second)
{
  DS1302_DataWrite(0x8e,0x00);                  // ȡд */
  DS1302_DataWrite(0x80,DECtoBCD(Second));      // 
  //DS1302_DataWrite(0x82,DECtoBCD(Minute));      // ÷
  //DS1302_DataWrite(0x84,DECtoBCD(Hour));        // Сʱ
  //DS1302_DataWrite(0x86,DECtoBCD(Day));         // 
  //DS1302_DataWrite(0x88,DECtoBCD(Month));       // 
  //DS1302_DataWrite(0x8a,DECtoBCD(Week));        // ڼ
  //DS1302_DataWrite(0x8c,DECtoBCD(Year));        // 
  DS1302_DataWrite(0x8e,0x80);                  // д */
}

// õʱ
void DS1302_GetTime(void)
{  
  Now.Second = BCDtoDEC(DS1302_DataRead(0x81)); // ȡ
  Now.Minute = BCDtoDEC(DS1302_DataRead(0x83)); // ȡ
  Now.Hour   = BCDtoDEC(DS1302_DataRead(0x85)); // ȡСʱ
  Now.Day    = BCDtoDEC(DS1302_DataRead(0x87)); // ȡ
  Now.Month  = BCDtoDEC(DS1302_DataRead(0x89)); // ȡ
  Now.Week   = BCDtoDEC(DS1302_DataRead(0x8b)); // ȡڼ
  Now.Year   = BCDtoDEC(DS1302_DataRead(0x8d)); // ȡ
}

// DS1302ʼ   
void InitDS1302(void)
{
  PIN_DS1302_RST_DOUT;          // RST 
  PIN_DS1302_RST_HIGH;
  PIN_DS1302_RST_LOW;           // DS1302_RST = 0;
  PIN_DS1302_RST_DIN;           // RST 
  DS1302_DataWrite(0x8e, 0x00); // д
  DS1302_DataWrite(0x80, 0x00); // ʱ
  DS1302_GetTime();             // ȡʱ
}

void DS1302_WriteByteRAM(unsigned char Address, unsigned char Data)
{
  Address = Address << 1;
  DS1302_DataWrite(0x8e,0x00);            // ȡд
  DS1302_DataWrite(0xc0 + Address, Data);
  DS1302_DataWrite(0x8e,0x80);            // д
}

void DS1302_WriteIntRAM(unsigned char Address, unsigned int Data)
{
  Address = Address << 1;
  DS1302_DataWrite(0x8e,0x00);           // ȡд
  DS1302_DataWrite(0xc0 + Address, Data % 256);
  DS1302_DataWrite(0xc0 + Address + 0x02, Data / 256);
  DS1302_DataWrite(0x8e,0x80);           // д
}

unsigned char DS1302_ReadByteRAM(unsigned char Address)
{
  unsigned char Temp;
  Address = (Address << 1) + 0x01;
  Temp = DS1302_DataRead(0xc0 + Address);
  return (Temp);
}

unsigned int DS1302_ReadIntRAM(unsigned char Address)
{
  unsigned char TempH;
  unsigned char TempL;
  unsigned int TempI;
  Address = (Address << 1) + 0x01;
  TempL = DS1302_DataRead(0xc0 + Address);
  TempH = DS1302_DataRead(0xc0 + Address + 0x02);
  TempI = TempH * 256 + TempL;
  return (TempI);
}


