
#include "Display.h"

// ʾ
#define Display_Locate            T6963_Locate  /* ҺָͷļĶλ */
#define Display_INIT              T6963_Init    /* Һָͷļĳʼ */
#define Display_CLEAR             T6963_Clear   /* Һָͷļ */
// ֿԴ
#define DOTAR_5X8E                chardot5X8E   /* 5*8 ӢAscii */
#define DOTAR_8X16E               chardot8x16E  /* 8*16 ӢAscii */
#define DOTAR_16X16HZ             hzdot         /* 16*16 ֿ */
#define INDEX_16X16HZ             hzIndex       /* 16*16 ֿ */
#define NUMHZ_16X16HZ             hzNum         /* 16*16 ֿ */

/* --------------------------------    ʾ    -------------------------------- */
// дһֽ, XصYص(ģX=8,Y=1; ģX=1,Y=8;)
#if (DISPLAY_MODE == H_MODE)
  #define PIXEL_X                 (8)     // ģ
  #define PIXEL_Y                 (1)
#else
  #define PIXEL_X                 (1)     // ģ
  #define PIXEL_Y                 (8)
#endif
// תx,yֵ
#define CONV_X(x)                 (x / PIXEL_X)
#define CONV_Y(y)                 (y / PIXEL_Y)
// ˫ģʽ(M_5X8E, M_8X16)
#if (DISPLAY_MODE == H_MODE)
  #define DISPLAY_MODE_5X8E       DISABLE  // ģҺ֧M_5X8Eģʽ
  #define DISPLAY_MODE_8X16       ENABLE
#else
  #define DISPLAY_MODE_5X8E       ENABLE
  #define DISPLAY_MODE_8X16       ENABLE
#endif
/* ------------------------------------------------------------------------------- */

void Display_Init(void)
{
  Display_INIT();
}

void Display_Clear(void)
{
  Display_CLEAR();
}

// ʾͨͼƬ(ͼָ, , , , )
void Display_Image(unsigned char const *Img, unsigned int x, unsigned char y, unsigned char Width, unsigned char High, unsigned char Flg_Inv)
{
  unsigned char r, c;           // ʱ
  unsigned int Count_Img = 0;
  for(r=0; r<CONV_Y(High); r++)
  {
    for(c=0; c<CONV_X(Width); c++)
    {
      Display_Locate((CONV_X(x) + c), ( + r), Img[Count_Img], Flg_Inv);
      Count_Img++;
    }
  }
}


// ʾAscii(Asciiַ, , )
void Display_Ascii(unsigned char Char, unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char c, r;
  unsigned char CharData;
  unsigned int  Start;    // ģֿеʼλ
  
  #if (DISPLAY_MODE_8X16 == ENABLE)
  if (Mode == M_8X16)
  {
    // ʾASCII(M_8X16ģʽ, Ч)
    Start = (Char-0x20) * 16;                                                   // ֿ
    for(r=0; r<CONV_Y(16); r++)                                                 // ѭ(ģ16, ģ2)
    {
      for(c=0; c<CONV_X(8); c++)                                                // ѭ(ģ1, ģ8)
      {
        CharData = DOTAR_8X16E[Start + r * CONV_X(8) + c];                     // ȡֿ
        Display_Locate((CONV_X(x)+ c), (CONV_Y(y) + r), CharData, Flg_Inv);     // 
      }
    }
  }
  #endif
  
  #if (DISPLAY_MODE_5X8E == ENABLE)
  if (Mode == M_5X8E)
  {
    // ʾASCII(M_5X8Eģʽ, ģЧ)
    Start = (Char-0x20) * 8;                                                    // ֿ
    for(c=0; c<5; c++)                                                          // ѭ(ģx, ģ5)
    {
      CharData = DOTAR_5X8E[Start + c];                                         // ȡֿ
      Display_Locate((CONV_X(x)+ c), CONV_Y(y), CharData, Flg_Inv);             // 
    }
    Display_Locate((CONV_X(x)+ 5), CONV_Y(y), 0x00, Flg_Inv);                   // ׷һո
  }
  #endif
}

// ʾ(, [ֽ], )
void Display_Chinese(unsigned int UniCode, unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char c, r;
  unsigned int  CodeID;       // ֿ
  unsigned char HzData;       // 
  unsigned int  Start;        // ģֿеʼλ
  
  if ((Mode != M_5X8E)&&(Mode != M_8X16)) return;
    
  // ֿ
  for(CodeID=0; CodeID<NUMHZ_16X16HZ; CodeID++)
  {
    if ((INDEX_16X16HZ[2*CodeID] == (UniCode/256)) && (INDEX_16X16HZ[2*CodeID+1] == (UniCode%256))){break;}
  }
  Start = CodeID * 32;
  
  #if ((DISPLAY_MODE_8X16 == ENABLE)||(DISPLAY_MODE_5X8E == ENABLE))            // 8X165X8Eģʽ¶ʾ, 16x16
  // ʾ
  for(r=0; r<CONV_Y(16); r++)                                                   // ѭ(ģ16, ģ2)
  {
    for(c=0; c<CONV_X(16); c++)                                                 // ѭ(ģ2, ģ16)
    {
      HzData = DOTAR_16X16HZ[Start + (CONV_X(16) * r) + c]; 
      Display_Locate((CONV_X(x)+c), (CONV_Y(y)+r), HzData, Flg_Inv);
    }
  }
  #endif
  
}

// ʾ(, , , ʾ)
void Display_Number(unsigned long int Number, unsigned char x, unsigned char y, unsigned char Lenth, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char DispNum;
  unsigned char Tmp_x;
  unsigned char NumberWidth;
  if(Mode == M_8X16) NumberWidth = 8;
  if(Mode == M_5X8E) NumberWidth = 6;
  // ʾ
  Tmp_x = x + (Lenth-1) * NumberWidth;
  for(; Lenth>0; Lenth--)
  {
    DispNum = Number % 10 + '0';
    Display_Ascii(DispNum, Tmp_x, y, Mode, Flg_Inv);
    Tmp_x -= NumberWidth;
    Number = Number / 10;
  }
}

// ʾ(, , , ʾ)
void Display_SignedNumber(signed long int Number, unsigned char x, unsigned char y, unsigned char Lenth, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char SignedWidth = 0;
  if(Mode == M_5X8E) SignedWidth = 6;
  if(Mode == M_8X16) SignedWidth = 8;
  
  if(Number < 0)
  {
    Display_Ascii(NEGSIGN, x, y, Mode, Flg_Inv);                          // ʾ
    Display_Number(-Number, (x+SignedWidth), y, Lenth, Mode, Flg_Inv);    // ʾ
  }
  else
  {
    Display_Ascii(POSSIGN, x, y, Mode, Flg_Inv);                          // ʾ
    Display_Number(Number, (x+SignedWidth), y, Lenth, Mode, Flg_Inv);    // ʾ
  }
}

// ʾС(, , , , С)
void Display_Decimal(unsigned long int Number, unsigned char x, unsigned char y, unsigned char IntLenth, unsigned char DecLenth, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char DispNum;
  unsigned char i;
  unsigned char Tmp_x;
  unsigned char NumberWidth;
  if(Mode == M_8X16) NumberWidth = 8;
  if(Mode == M_5X8E) NumberWidth = 6;
  
  Tmp_x = x + IntLenth * NumberWidth + DecLenth * NumberWidth;
  for(i=0; i<(DecLenth+IntLenth); i++)
  {
    DispNum = Number % 10 + 0x30;                                               // ʾֵASCII
    Display_Ascii(DispNum, Tmp_x, y, Mode, Flg_Inv);                           // ȡģ
    Tmp_x -= NumberWidth;
    if (Tmp_x == (x + IntLenth * NumberWidth))
    {
      Display_Ascii('.', Tmp_x, y, Mode, Flg_Inv); 
      Tmp_x -= NumberWidth;
    }
    Number = Number / 10;
  }
}

// ʾС(, , , , С)
void Display_SignedDecimal(signed long int Number, unsigned char x, unsigned char y, unsigned char IntLenth, unsigned char DecLenth, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char SignedWidth = 0;
  if(Mode == M_5X8E) SignedWidth = 6;
  if(Mode == M_8X16) SignedWidth = 8;
  
  if (Number < 0)
  {
     Display_Decimal(-Number, (x+SignedWidth), y, IntLenth, DecLenth, Mode, Flg_Inv);
     Display_Ascii(NEGSIGN, x, y, Mode, Flg_Inv);
  }
  else
  {
     Display_Decimal( Number, (x+SignedWidth), y, IntLenth, DecLenth, Mode, Flg_Inv);
     Display_Ascii(POSSIGN, x, y, Mode, Flg_Inv);
  }
}

// ʾַ(ַָ, , )
void Display_String(unsigned char const *p, unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char i;
  unsigned char Tmp_x = x;
  unsigned char AsciiWidth;
  if(Mode == M_8X16) AsciiWidth = 8;
  if(Mode == M_5X8E) AsciiWidth = 6;
  
  if(Mode == M_5X8E)
  {
    for(i=0; i<80;i++)
    {
      if (p[i] == ENDSTRING){break;}
      Display_Ascii(p[i], Tmp_x, y, Mode, Flg_Inv);
      Tmp_x += AsciiWidth;
    }
  }
  
  if(Mode == M_8X16)
  {
    for(i=0; i<80;i++)
    {
      if (p[i] == ENDSTRING){break;}
      if (p[i] < 0x80)
      {
        Display_Ascii(p[i], Tmp_x, y, Mode, Flg_Inv); 
        Tmp_x += AsciiWidth;
      }
      else
      {
        Display_Chinese((p[i]*256+p[i+1]), Tmp_x, y, Mode, Flg_Inv); 
        Tmp_x += AsciiWidth*2; i++;
      }
    }
  }
}

// ʾ
void Display_Bar(unsigned int Value, unsigned int Max, unsigned char x_Start, unsigned char x_End, unsigned char y_Byte, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned int MaxLength = (x_End - x_Start);
  unsigned int ShowLength;
  unsigned char i;
  
  if (Mode == M_5X8E)
  {
    ShowLength = (unsigned int)((unsigned long int)Value * MaxLength / Max);
    if (ShowLength > MaxLength){ShowLength = MaxLength;}
    for(i=x_Start; i<=x_End; i++)
    {
      if ((i == x_Start) || (i == x_End)) {Display_Locate(i, y_Byte, 0xfe, Flg_Inv); continue;}
      if ((i == x_Start+1) || (i == x_End-1)){Display_Locate(i, y_Byte, 0xfe, Flg_Inv); continue;}  // 0x82
      if (i < ShowLength+x_Start){Display_Locate(i, y_Byte, 0xfe, Flg_Inv); }    // 0xba
      else{Display_Locate(i, y_Byte, 0x82, Flg_Inv); }
    }
  }
}

// ʾ
void Display_VScroll(unsigned int Value, unsigned int Max, unsigned char x, unsigned char y_Start, unsigned char y_End, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned int MaxLength = (y_End - y_Start);   // ĳ
  unsigned int BlockLength;                     // ĳ
  unsigned char i;
  
  if (Mode == M_8X16)
  {
    BlockLength = MaxLength / (Max+1) + 1;
    if (BlockLength <= 6) BlockLength = 6;
    if (BlockLength > MaxLength){BlockLength = MaxLength;}
    for(i=0; i<=MaxLength; i++)
    {
      if ((i == 0) || (i == MaxLength))
      {
        Display_Locate(x, i+y_Start, 0xfe, Flg_Inv); 
        continue;
      }
      if((i > (BlockLength * Value))&&(i < BlockLength * (Value+1)))
      {
        Display_Locate(x, i+y_Start, 0xfe, Flg_Inv); 
      }  
      else
      {
        Display_Locate(x, i+y_Start, 0x82, Flg_Inv);
      }
    }
  }

}

void Display_Date(unsigned char Year, unsigned char Month, unsigned char Day, 
                  unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char Tmp_x = x;
  unsigned char AsciiWidth;
  if(Mode == M_8X16) AsciiWidth = 8;
  if(Mode == M_5X8E) AsciiWidth = 6;
  
  Display_Number(Year,   Tmp_x, y, 2, Mode, Flg_Inv);  Tmp_x += AsciiWidth*2;
  Display_String("/\n",  Tmp_x, y, Mode, Flg_Inv);     Tmp_x += AsciiWidth;
  Display_Number(Month,  Tmp_x, y, 2, Mode, Flg_Inv);  Tmp_x += AsciiWidth*2;
  Display_String("/\n",  Tmp_x, y, Mode, Flg_Inv);     Tmp_x += AsciiWidth;
  Display_Number(Day,    Tmp_x, y, 2, Mode, Flg_Inv);
}

void Display_Time(unsigned char Hour, unsigned char Minute, unsigned char Second, 
                  unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char Tmp_x = x;
  unsigned char AsciiWidth;
  if(Mode == M_8X16) AsciiWidth = 8;
  if(Mode == M_5X8E) AsciiWidth = 6;
  
  Display_Number(Hour,   Tmp_x, y, 2, Mode, Flg_Inv);  Tmp_x += AsciiWidth*2;
  Display_String(":\n",  Tmp_x, y, Mode, Flg_Inv);     Tmp_x += AsciiWidth;
  Display_Number(Minute, Tmp_x, y, 2, Mode, Flg_Inv);  Tmp_x += AsciiWidth*2;
  Display_String(":\n",  Tmp_x, y, Mode, Flg_Inv);     Tmp_x += AsciiWidth;
  Display_Number(Second, Tmp_x, y, 2, Mode, Flg_Inv);
}

void Display_Block(unsigned char Fill, unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char i;
  if (Mode == M_5X8E)
  {
    for(i=0; i<11; i++)
    {
      if ((i == 0)||(i == 10))
      {
        Display_Locate(x+i, y, 0x7f, Flg_Inv);
      }
      else
      {
        if (Fill == 0){Display_Locate(x+i, y, 0x41, Flg_Inv);}
        else{Display_Locate(x+i, y, 0x7f, Flg_Inv);}
      }
    }
  }
}

void Display_3HalfNumber(unsigned char const * String,  float Data, unsigned char const * Unit, unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv)
{
  unsigned char Format;           // ݸʽ
  unsigned int  Bias = 0;         // xƫ
  unsigned char Length = 0;       // ʾַ
  unsigned long int ShowData;     // 󴫸ʾ
  unsigned char AsciiWidth;
  if(Mode == M_8X16) AsciiWidth = 8;
  if(Mode == M_5X8E) AsciiWidth = 6;
  
  // ʾַ
  while(String[Length] != '\n')
  {                      
    Length++;
  }
  // ݸʽ
  if (Data < 2.0) {Format = 0; goto Label_Current;}
  if (Data < 20.0) {Format = 1; goto Label_Current;}
  if (Data < 200.0) {Format = 2; goto Label_Current;}
  if (Data < 2000.0) {Format = 3; goto Label_Current;}
  if (Data < 20000.0) {Format = 4; goto Label_Current;}
  if (Data < 200000.0) {Format = 5; goto Label_Current;}
  if (Data < 2000000.0) {Format = 6; goto Label_Current;}
  if (Data < 20000000.0) {Format = 7; goto Label_Current;}
  Label_Current:
  // ʾʾַ
  Display_String(String, x, y, Mode, Flg_Inv);
  Bias = Length * AsciiWidth;
  // ʾ
  switch(Format)
  {
    case 0: ShowData = (signed long int)(Data * 1000.0);  
            Display_Decimal(ShowData, (x + Bias), y, 1, 3, Mode, Flg_Inv); break;
    case 1: ShowData = (signed long int)(Data * 100.0);   
            Display_Decimal(ShowData, (x + Bias), y, 2, 2, Mode, Flg_Inv); break;
    case 2: ShowData = (signed long int)(Data * 10.0);    
            Display_Decimal(ShowData, (x + Bias), y, 3, 1, Mode, Flg_Inv); break;
    case 3: ShowData = (signed long int)(Data);         
            Display_Decimal(ShowData, (x + Bias), y, 1, 3, Mode, Flg_Inv); break;
    case 4: ShowData = (signed long int)(Data / 10.0);    
            Display_Decimal(ShowData, (x + Bias), y, 2, 2, Mode, Flg_Inv); break;
    case 5: ShowData = (signed long int)(Data / 100.0);   
            Display_Decimal(ShowData, (x + Bias), y, 3, 1, Mode, Flg_Inv); break;
    case 6: ShowData = (signed long int)(Data / 1000.0);  
            Display_Decimal(ShowData, (x + Bias), y, 1, 3, Mode, Flg_Inv); break;
    case 7: ShowData = (signed long int)(Data / 10000.0); 
            Display_Decimal(ShowData, (x + Bias), y, 2, 2, Mode, Flg_Inv); break;
  }
  Bias += 5 * AsciiWidth;
  // ʾλ
  switch(Format)
  {
    case 0: case 1: case 2: break;
    case 3: case 4: case 5: Display_String("K\n", (x + Bias), y, Mode, Flg_Inv); Bias += AsciiWidth; break;
    case 6: case 7:         Display_String("M\n", (x + Bias), y, Mode, Flg_Inv); Bias += AsciiWidth; break;
  }
  Display_String(Unit, (x + Bias), y, Mode, Flg_Inv);
}

void Display_Test1(void)
{
  // ʾAscii
  Display_Ascii('A',  0, 0, M_8X16, D_NOR);
  Display_Ascii('s',  8, 0, M_8X16, D_INV);
  Display_Ascii('c', 16, 0, M_8X16, D_NOR);
  Display_Ascii('i', 24, 0, M_8X16, D_INV);
  Display_Ascii('i', 32, 0, M_8X16, D_NOR);
  // ʾ
  Display_Chinese(0xb5a5, 64, 0, M_8X16, D_NOR);
  Display_Chinese(0xd7d6, 80, 0, M_8X16, D_INV);
  // ޷
  Display_Number(314, 0, 16, 4, M_8X16, D_INV);
  // з
  Display_SignedNumber( 351, 64, 16, 4, M_8X16, D_INV);
  Display_SignedNumber(-351, 64, 32, 4, M_8X16, D_NOR);  
  // ޷С
  Display_Decimal(31415, 0, 32, 1, 4, M_8X16, D_NOR);
  // зС
  Display_SignedDecimal( 618,  0, 48, 1, 3, M_8X16, D_NOR);
  Display_SignedDecimal(-618, 64, 48, 1, 3, M_8X16, D_NOR);

  Display_Clear(); 
}

void Display_Test2(void)
{
  // ַ
  Display_String("Ag1+!~\n", 0, 0, M_8X16, D_NOR);  
  // ʱ
  Display_Date(7,  7, 29,  0, 16, M_8X16, D_NOR);
  Display_Time(1, 34, 25, 64, 16, M_8X16, D_NOR);
  // λʾ
  Display_3HalfNumber("Ia=\n", 5.321, "A\n", 0, 32, M_8X16, D_NOR);

  Display_Clear(); 
}
