#ifndef _DISPLAY_H
#define _DISPLAY_H

//#include "Global.h"
#include "T6963.h"
#include "Ascii5x8E.h"
#include "Ascii8x16E.h"
#include "HanZi.h"

extern void Display_Clear(void);
extern void Display_Init(void);
extern void Display_Image(unsigned char const *Img, unsigned int x, unsigned char y, unsigned char Width, unsigned char High, unsigned char Flag_Inv);
extern void Display_Ascii(unsigned char Char, unsigned char x, unsigned char y, unsigned char Mode, unsigned char FLag_Inv);
extern void Display_Chinese(unsigned int UniCode, unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv);
extern void Display_Number(unsigned long int Number, unsigned char x, unsigned char y, unsigned char Lenth, unsigned char Mode, unsigned char FLag_Inv);
extern void Display_SignedNumber(long int Number, unsigned char x, unsigned char y, unsigned char Lenth, unsigned char Mode, unsigned char FLag_Inv);
extern void Display_Decimal(unsigned long int Number, unsigned char x, unsigned char y, unsigned char IntLenth, unsigned char DecLenth, unsigned char Mode, unsigned char FLag_Inv);
extern void Display_SignedDecimal(signed long int Number, unsigned char x, unsigned char y, unsigned char IntLenth, unsigned char DecLenth, unsigned char Mode, unsigned char Flg_Inv);
extern void Display_String(unsigned char const *p, unsigned char x, unsigned char y, unsigned char Mode, unsigned char FLag_Inv);
extern void Display5x8E_Bar(unsigned int Value, unsigned int Max, unsigned char x_Start, unsigned char x_End, unsigned char y_Byte, unsigned char FLag_Inv);
extern void Display_Date(unsigned char Year, unsigned char Month, unsigned char Day, 
                         unsigned char x, unsigned char y, unsigned char Mode, unsigned char FLag_Inv);
extern void Display_Time(unsigned char Hour, unsigned char Minute, unsigned char Second, 
                         unsigned char X, unsigned char Y, unsigned char Mode, unsigned char FLag_Inv);
extern void Display_Block(unsigned char Fill, unsigned char x, unsigned char y, unsigned char Mode, unsigned char FLag_Inv);
extern void Display_3HalfNumber(unsigned char const * String,  float Data, unsigned char const * Unit, unsigned char x, unsigned char y, unsigned char Mode, unsigned char Flg_Inv);

extern void Display_VScroll(unsigned int Value, unsigned int Max, unsigned char x, unsigned char y_Start, unsigned char y_End, unsigned char Mode, unsigned char Flg_Inv);
extern void Display_Test2(void);

#define V_MODE                    (0)     // ģʾ
#define H_MODE                    (1)     // ģʾ
#define DISPLAY_MODE              H_MODE  // <- ޸ΪǰҺģʽ

// ʾ
#define POSSIGN                   (' ')   // ֵ
#define NEGSIGN                   ('-')   // ֵĸ
#define ENDSTRING                 ('\n')  // ַ

#define M_5X8E                    ('E')
#define M_8X16                    ('C')


#endif

