#ifndef __KEY_H
#define __KEY_H

#include <msp430x14x.h>
#include "Global.h"

#define PIN_KEYIN_OUT           P1OUT
#define PIN_KEYIN_IN            P1IN
#define PIN_KEYIN_DIR           P1DIR

#define KEYIN                   (0xff)
#define NOKEY                   (0x00)
#define LONG_PRESS_FLAG         (0x03)
// [˶,˶,Բ˶,ѭ˶,,ѡ,ȷ]
#define KEY_Free                (0x01)
#define KEY_Spot                (0x02)
#define KEY_Circle              (0x04)
#define KEY_Find                (0x08)
#define KEY_ADD                 (0x10)
#define KEY_SUB                 (0x20)
#define KEY_SEL                 (0x40)
#define KEY_ENT                 (0x80)
#define KEY_ADD_L               (KEY_ADD + LONG_PRESS_FLAG)
#define KEY_SUB_L               (KEY_SUB + LONG_PRESS_FLAG)
#define KEY_SEL_L               (KEY_SEL + LONG_PRESS_FLAG)
#define KEY_ENT_L               (KEY_ENT + LONG_PRESS_FLAG)
// ض[, , , ]
#define KEY_UUP                 KEY_ADD
#define KEY_DWN                 KEY_SUB
#define KEY_LFT                 KEY_SEL
#define KEY_RGH                 KEY_ENT
#define KEY_UUP_L               KEY_ADD_L
#define KEY_DWN_L               KEY_SUB_L
#define KEY_LFT_L               KEY_SEL_L
#define KEY_RGH_L               KEY_ENT_L



#define KEY_LIG                 (0x07)

#define BEEPER_ON               P6OUT &= ~BIT0
#define BEEPER_OFF              P6OUT |=  BIT0
#define BEEPER_DOUT             P6DIR |=  BIT0

#define BACKLIGHT_ON            //P4OUT |=  BIT6
#define BACKLIGHT_OFF           //P4OUT &= ~BIT6
#define BACKLIGHT_DOUT          //P4DIR |=  BIT6

extern void           Key_Init(void);
extern unsigned char  Key_Read(void);
extern unsigned char  Key_Scan(void);
extern unsigned char  Key_Get(void);
extern long int       Key_SetValue(unsigned char FuncKey, long int Value, long int Min, long int Max, unsigned int Step);
extern long int       Key_SetValue_pointunit(unsigned char FuncKey, long int Value, long int Min, long int Max, unsigned int Step);
extern long int       Key_SetValueY(unsigned char FuncKey, long int Value, long int Min, long int Max, unsigned int Step);
extern long int       Key_SetValueT(unsigned char FuncKey, long int Value, long int Min, long int Max, unsigned int Step);
extern void           Key_Beep(void);
extern void           Key_CheckOnTimerInterrupt(void);

#endif


