#include <msp430x14x.h>
#include "Display.h"
#include "T6963.h"
#include "Global.h"
#include "Key.h"
#include "Free_Sport.h"
#include "Spot_Sport.h"
#include "Circle_Sport.h"
#include "Find_Sport.h"
#include "Math.h"
#include "DS1302.h"
#include "Timer_A.h"
#include "Pot_To_Pot.h"

void XT2_Init(void)
{
  unsigned char i;
  BCSCTL1 &= ~(XT2OFF);  
  do{
    IFG1 &= ~(OFIFG);                                                                                                                                                                                                                                                                                                                      
    for(i=0; i<100; i++){_NOP();}
  }while((IFG1 & OFIFG) != 0);
}

// ϵͳʱӳʼ
void BCS_Init(void)
{
  XT2_Init();
  /*---------------ϵͳʱ趨---------------
  // DCOΪ 4080KHz
  // ACLK Ϊ LFXT1(Ƶģʽ)
  // MCLK Ϊ XT2CLK
  // SMLCKΪ LFXT1CLK(11x/12x) / XT2CLK(13x+)  
  --------------------------------------------*/
  DCOCTL  = 0x60 + 0x00;
  BCSCTL1 = DIVA_0 + 0x04;
  BCSCTL2 = SELM_2 + DIVM_0 + SELS + DIVS_0;
}

void Hand_Control_TB_Init(void)
 {
   TBCTL    = TBSSEL_1 + TBCLR + ID_0 + MC_1; //ѡACLK,㣬Ƶģʽ
   TBCCTL3 |= OUTMOD_7;
   TBCCTL6 |= OUTMOD_7;
 }

  main( void )
{ 
   WDTCTL = WDTPW + WDTHOLD;
   BCS_Init();
   Display_Init();
   TA_Init();
  
  while(1)   
  {
    unsigned char Key_value;
    unsigned char hand_control=0;
    Display_String("                \n", 0, 0, M_8X16, D_INV);
    Display_String("            \n", 0, 16, M_8X16, D_INV);
    Display_String("  ˶ϵͳ  \n", 0, 32, M_8X16, D_INV);
    Display_String("                \n", 0, 48, M_8X16, D_INV);
    Key_value= Key_Scan();
    switch(Key_value)
    { 
      case  KEY_Free  : 
        {
          Free_mode=1;  
          Display_Clear();  
          Cacu_Free_Sport(); 
          break; 
        }
      case  KEY_Spot  :  
       { 
         Spot_mode=1; 
         Display_Clear(); 
         Cacu_Spot_Sport();  
         break;
       }
      case  KEY_Circle:     
        { Circle_mode=1;
          Display_Clear(); 
          Cacu_Circle_Sport(); 
          break; 
        }
      case  KEY_Find  : 
        { Find_mode=1;
          Display_Clear();  
          Cacu_Find_Sport();
          break;
        }
      case  KEY_ADD_L  : 
        {
         hand_control=1;
          break;
        }
      default : break; 
    } 
    while(hand_control)
       { MTOR_A_CLK_OFF;
         MTOR_B_CLK_OFF;
         Hand_Control_TB_Init();
         Key_value= Key_Scan();
         if(Key_value==KEY_ADD_L)  
         {
           hand_control=0;
           MTOR_A_CLK_OFF;
           MTOR_B_CLK_OFF;
           MTOR_A_OFF ;
           MTOR_B_OFF ;
           break;
         
         }

          while(Key_value==0x10)
            { 
              MTOR_A_ON ;        
              MTOR_A_RUN_UP; 
              MTOR_A_CLK_ON ;
              DelayNms(300); 
              break;
             }
         while(Key_value==0x20)
           { 
             MTOR_A_ON ;        
             MTOR_A_RUN_DOWN ;
             MTOR_A_CLK_ON ;
             DelayNms(300);
             break;        
           }
       while(Key_value==0x40)
           { 
            MTOR_B_ON ;        
            MTOR_B_RUN_UP ;    
            MTOR_B_CLK_ON ;
            DelayNms(300); 
            break;
           }
       while(Key_value==0x80)
          { 
           MTOR_B_ON ;        
           MTOR_B_RUN_DOWN ;    
           MTOR_B_CLK_ON ;
           DelayNms(300);  
           break;
          }
    
       }
    }  
 }
